--

-- the function which should be fixed

local function TradeSkillGuilCraftersFrame_UpdateFix()
    local skillLineID, recipeID, numMembers = GetGuildRecipeInfoPostQuery();
    local offset = FauxScrollFrame_GetOffset(TradeSkillGuildCraftersFrame);
    local index, button, name, online;
    
    for i = 1, TRADE_SKILL_GUILD_CRAFTERS_DISPLAYED, 1 do
        index = i + offset;
        button = _G["TradeSkillGuildCrafter"..i];
        if ( index > numMembers ) then
            button:Hide();
        else
            name, classFileName, online = GetGuildRecipeMember(index);
            
            button:SetText(name);
            if ( online ) then
                button:Enable();
                if ( classFileName ) then
                    local classColor = RAID_CLASS_COLORS[classFileName];
                    --            print(name,classFileName,online,index)
                    _G["TradeSkillGuildCrafter"..i.."Text"]:SetTextColor(classColor.r, classColor.g, classColor.b);                
                end
            else
                button:Disable();
                _G[ button:GetName() .. "Text"]:SetTextColor(0.5,0.5,0.5,1)
            end
            button:Show();
            button.name = name;
        end
    end
    FauxScrollFrame_Update(TradeSkillGuildCraftersFrame, numMembers, TRADE_SKILL_GUILD_CRAFTERS_DISPLAYED, TRADE_SKILL_HEIGHT);
end

local function GuildRosterFrame_OnShowFix(self)
	GuildRoster_RecipeQueryCheck();
	GuildRoster_Update();
	if GetCVar("guildRosterView") == "tradeskill" then
		GuildRoster_UpdateTradeSkills()
	end
end

--fix problems when TradeSkill UI loaded

local function AddonLoaded(self,event,name)
	if name == "Blizzard_TradeSkillUI" then
		TradeSkillGuilCraftersFrame_Update = TradeSkillGuilCraftersFrame_UpdateFix
	elseif name == "Blizzard_GuildUI" then
		GuildRosterFrame_OnShow = GuildRosterFrame_OnShowFix
	end
end

local F = CreateFrame("frame")
F:RegisterEvent("ADDON_LOADED")
F:SetScript("OnEvent",AddonLoaded)